diff --git a/liboctave/array/CSparse.cc b/liboctave/array/CSparse.cc
--- a/liboctave/array/CSparse.cc
+++ b/liboctave/array/CSparse.cc
@@ -512,6 +538,871 @@ SparseComplexMatrix::min (Array<octave_i
 
 */
 
+SparseComplexMatrix
+SparseComplexMatrix::cummax (int dim, bool includenan) const
+{
+  SparseComplexMatrix result;
+  dim_vector dv = dims ();
+  octave_idx_type nr = dv(0);
+  octave_idx_type nc = dv(1);
+
+  if (dim >= dv.ndims ())
+    return *this;
+
+  if (dim < 0)
+    dim = dv.first_non_singleton ();
+
+  if (nr == 0 || nc == 0 || dim >= dv.ndims ())
+    return SparseComplexMatrix (nr, nc);
+
+  if (dim == 0)
+    {
+      octave_idx_type nel = 0;
+      for (octave_idx_type j = 0; j < nc; j++)
+        {
+          octave_idx_type i = cidx (j);
+          if (includenan)
+            {
+              if (i < cidx (j+1))
+                nel += nr - ridx (i);
+            }
+          else
+            {
+              if (i < cidx (j+1) && ridx (i) == 0)
+                {
+                  octave_idx_type expected_r = 0;
+                  for (; i < cidx (j+1) && ridx (i) == expected_r; i++)
+                    {
+                      if (! octave::math::isnan (data (i)))
+                        break;
+                      expected_r++;
+                    }
+
+                  if (i < cidx (j+1) && ridx (i) == expected_r)
+                    {
+                      nel += nr;
+                      continue;
+                    }
+                  nel += expected_r;
+                }
+              for (; i < cidx (j+1); i++)
+                if (! octave::math::isnan (data (i)))
+                  {
+                    nel += nr - ridx (i);
+                    break;
+                  }
+            }
+        }
+
+      result = SparseComplexMatrix (nr, nc, nel);
+      octave_idx_type ii = 0;
+      result.xcidx (0) = 0;
+
+      for (octave_idx_type j = 0; j < nc; j++)
+        {
+          octave_idx_type i = cidx (j);
+          if (i < cidx (j+1))
+            {
+              octave_idx_type last = 0;
+              bool zero_found = ridx (i) > 0;
+              Complex tmp_max = zero_found ? 0. : data (i++);
+
+              if (! zero_found
+                  && ((i < cidx (j+1) && ridx (i) > 1)
+                      || (i == cidx (j+1) && nr >= 2)))
+                {
+                  zero_found = true;
+                  if (octave::math::isnan (tmp_max) && ! includenan)
+                    {
+                      result.xdata (ii) = tmp_max;
+                      result.xridx (ii++) = 0;
+                      last = 1;
+                      tmp_max = 0.;
+                    }
+                }
+
+              for (; i < cidx (j+1); i++)
+                {
+                  if (data (i) > tmp_max
+                      || (includenan == octave::math::isnan (data (i))
+                          && includenan != octave::math::isnan (tmp_max)))
+                    {
+                      if (tmp_max != 0.)
+                        for (; last < ridx (i); last++)
+                          {
+                            result.xdata (ii) = tmp_max;
+                            result.xridx (ii++) = last;
+                          }
+                      last = ridx (i);
+                      tmp_max = data (i);
+                    }
+                  if (! zero_found
+                      && ((i + 1 < cidx (j+1) && ridx (i+1) > ridx (i) + 1)
+                          || (i + 1 == cidx (j+1) && ridx (i) < nr - 1)))
+                    {
+                      zero_found = true;
+                      if (octave::math::isnan (tmp_max) && ! includenan)
+                        {
+                          for (; last < ridx (i) + 1; last++)
+                            {
+                              result.xdata (ii) = tmp_max;
+                              result.xridx (ii++) = last;
+                            }
+                          last = ridx (i) + 1;
+                          tmp_max = 0.;
+                        }
+                    }
+                }
+              if (tmp_max != 0.)
+                for (; last < nr; last++)
+                  {
+                    result.xdata (ii) = tmp_max;
+                    result.xridx (ii++) = last;
+                  }
+            }
+          result.xcidx (j+1) = ii;
+        }
+    }
+  else
+    {
+      octave_idx_type nel = 0;
+
+      OCTAVE_LOCAL_BUFFER (octave_idx_type, expected_visit, nr);
+      OCTAVE_LOCAL_BUFFER (int8_t, max_sgn, nr);
+
+      for (octave_idx_type i = 0; i < nr; i++)
+        {
+          expected_visit[i] = 0;
+          max_sgn[i] = -1;
+        }
+
+      for (octave_idx_type j = 0; j < nc; j++)
+        for (octave_idx_type i = cidx (j); i < cidx (j+1); i++)
+          {
+            if (max_sgn[ridx (i)] <= 0)
+              {
+                bool end_of_zeros = (! octave::math::isnan (data (i))
+                                     || includenan);
+
+                if (max_sgn[ridx (i)] < 0)
+                  {
+                    if (expected_visit[ridx (i)] < j || end_of_zeros)
+                      {
+                        nel += expected_visit[ridx (i)];
+                        if (expected_visit[ridx (i)] < j)
+                          max_sgn[ridx (i)] = 0;
+                      }
+                    else
+                      expected_visit[ridx (i)]++;
+                  }
+                if (end_of_zeros)
+                  {
+                    max_sgn[ridx (i)] = 1;
+                    nel += nc - j;
+                  }
+              }
+          }
+
+      for (octave_idx_type i = 0; i < nr; i++)
+        if (max_sgn[i] < 0)
+          nel += expected_visit[i];
+
+      result = SparseComplexMatrix (nr, nc, nel);
+      octave_idx_type ii = 0;
+      result.xcidx (0) = 0;
+
+      for (octave_idx_type i = cidx (0); i < cidx (1); i++)
+        {
+          result.xdata (ii) = data (i);
+          result.xridx (ii++) = ridx (i);
+        }
+      result.xcidx (1) = ii;
+
+      for (octave_idx_type j = 1; j < nc; j++)
+        {
+          octave_idx_type i = cidx (j);
+          octave_idx_type i_max = cidx (j+1);
+          bool i_lt_max = i < i_max;
+
+          octave_idx_type r = result.cidx (j-1);
+          octave_idx_type r_max = result.cidx (j);
+          bool r_lt_max = r < r_max;
+
+          while (i_lt_max || r_lt_max)
+            {
+              octave_quit ();
+              Complex i_val, r_val;
+              octave_idx_type row;
+
+              if (! r_lt_max || (i_lt_max && ridx (i) < result.ridx (r)))
+                {
+                  i_val = data (i);
+                  r_val = 0.;
+                  row = ridx (i++);
+                  i_lt_max = i < i_max;
+                }
+              else if (! i_lt_max || (r_lt_max && result.ridx (r) < ridx (i)))
+                {
+                  i_val = 0.;
+                  r_val = result.data (r);
+                  row = result.ridx (r++);
+                  r_lt_max = r < r_max;
+                }
+              else
+                {
+                  i_val = data (i);
+                  r_val = result.data (r);
+                  row = ridx (i++);
+                  i_lt_max = i < i_max;
+                  r++;
+                  r_lt_max = r < r_max;
+                }
+
+              Complex tmp;
+              if (includenan)
+                tmp = r_val >= i_val ? r_val : (octave::math::isnan (r_val)
+                                                ? r_val : i_val);
+              else
+                tmp = octave::math::max (r_val, i_val);
+              if (tmp != 0.)
+                {
+                  result.data (ii) = tmp;
+                  result.ridx (ii++) = row;
+                }
+            }
+          result.xcidx (j+1) = ii;
+        }
+    }
+
+  return result;
+}
+
+SparseComplexMatrix
+SparseComplexMatrix::cummax (Array<octave_idx_type>& idx_arg,
+                             int dim, bool includenan) const
+{
+  SparseComplexMatrix result;
+  dim_vector dv = dims ();
+  octave_idx_type nr = dv(0);
+  octave_idx_type nc = dv(1);
+
+  if (dim >= dv.ndims ())
+    {
+      idx_arg.resize (dim_vector (nr, nc), 0);
+      return *this;
+    }
+
+  if (dim < 0)
+    dim = dv.first_non_singleton ();
+
+  idx_arg.resize (dim_vector (nr, nc));
+
+  if (nr == 0 || nc == 0 || dim >= dv.ndims ())
+    return SparseComplexMatrix (nr, nc);
+
+  if (dim == 0)
+    {
+      octave_idx_type nel = 0;
+      for (octave_idx_type j = 0; j < nc; j++)
+        {
+          octave_idx_type i = cidx (j);
+          if (includenan)
+            {
+              if (i < cidx (j+1))
+                nel += nr - ridx (i);
+            }
+          else
+            {
+              if (i < cidx (j+1) && ridx (i) == 0)
+                {
+                  octave_idx_type expected_r = 0;
+                  for (; i < cidx (j+1) && ridx (i) == expected_r; i++)
+                    {
+                      if (! octave::math::isnan (data (i)))
+                        break;
+                      expected_r++;
+                    }
+
+                  if (i < cidx (j+1) && ridx (i) == expected_r)
+                    {
+                      nel += nr;
+                      continue;
+                    }
+                  nel += expected_r;
+                }
+              for (; i < cidx (j+1); i++)
+                if (! octave::math::isnan (data (i)))
+                  {
+                    nel += nr - ridx (i);
+                    break;
+                  }
+            }
+        }
+
+      result = SparseComplexMatrix (nr, nc, nel);
+      octave_idx_type ii = 0;
+      result.xcidx (0) = 0;
+      octave_idx_type i = cidx (0);
+
+      for (octave_idx_type j = 0; j < nc; j++)
+        {
+          Complex tmp_max = i < cidx (j+1) && ridx (i) == 0 ? data (i++) : 0.;
+          idx_arg.elem (0, j) = 0;
+          if (tmp_max != 0.)
+            {
+              result.xdata (ii) = tmp_max;
+              result.xridx (ii++) = 0;
+            }
+
+          for (octave_idx_type ir = 1; ir < nr; ir++)
+            {
+              Complex tmp = i < cidx (j+1) && ridx (i) == ir ? data (i++) : 0.;
+
+              if (tmp > tmp_max
+                  || (includenan == octave::math::isnan (tmp)
+                      && includenan != octave::math::isnan (tmp_max)))
+                {
+                  tmp_max = tmp;
+                  idx_arg.elem (ir, j) = ir;
+                }
+              else
+                idx_arg.elem (ir, j) = idx_arg.elem (ir - 1, j);
+              if (tmp_max != 0.)
+                {
+                  result.xdata (ii) = tmp_max;
+                  result.xridx (ii++) = ir;
+                }
+            }
+
+          result.xcidx (j+1) = ii;
+        }
+    }
+  else
+    {
+      octave_idx_type nel = 0;
+
+      OCTAVE_LOCAL_BUFFER (octave_idx_type, expected_visit, nr);
+      OCTAVE_LOCAL_BUFFER (int8_t, max_sgn, nr);
+
+      for (octave_idx_type i = 0; i < nr; i++)
+        {
+          expected_visit[i] = 0;
+          max_sgn[i] = -1;
+        }
+
+      for (octave_idx_type j = 0; j < nc; j++)
+        for (octave_idx_type i = cidx (j); i < cidx (j+1); i++)
+          {
+            if (max_sgn[ridx (i)] <= 0)
+              {
+                bool end_of_zeros = (! octave::math::isnan (data (i))
+                                     || includenan);
+
+                if (max_sgn[ridx (i)] < 0)
+                  {
+                    if (expected_visit[ridx (i)] < j || end_of_zeros)
+                      {
+                        nel += expected_visit[ridx (i)];
+                        if (expected_visit[ridx (i)] < j)
+                          max_sgn[ridx (i)] = 0;
+                      }
+                    else
+                      expected_visit[ridx (i)]++;
+                  }
+                if (end_of_zeros)
+                  {
+                    max_sgn[ridx (i)] = 1;
+                    nel += nc - j;
+                  }
+              }
+          }
+
+      for (octave_idx_type i = 0; i < nr; i++)
+        if (max_sgn[i] < 0)
+          nel += expected_visit[i];
+
+      result = SparseComplexMatrix (nr, nc, nel);
+      octave_idx_type ii = 0;
+      result.xcidx (0) = 0;
+
+      octave_idx_type i = cidx (0);
+      for (octave_idx_type ir = 0; ir < nr; ir++)
+        {
+          idx_arg.elem (ir, 0) = 0;
+          if (i < cidx (1) && ridx (i) == ir)
+            {
+              result.xdata (ii) = data (i++);
+              result.xridx (ii++) = ir;
+            }
+        }
+      result.xcidx (1) = ii;
+      octave_idx_type r = result.cidx (0);
+
+      for (octave_idx_type j = 1; j < nc; j++)
+        {
+          for (octave_idx_type ir = 0; ir < nr; ir++)
+            {
+              Complex tmp_max = (r < result.cidx (j) && result.ridx (r) == ir
+                                 ? result.data (r++) : 0.);
+              Complex tmp = i < cidx (j+1) && ridx (i) == ir ? data (i++) : 0.;
+              if (tmp > tmp_max
+                  || (includenan == octave::math::isnan (tmp)
+                      && includenan != octave::math::isnan (tmp_max)))
+                {
+                  idx_arg.elem (ir, j) = j;
+                  if (tmp != 0.)
+                    {
+                      result.xdata (ii) = tmp;
+                      result.xridx (ii++) = ir;
+                    }
+                }
+              else
+                {
+                  idx_arg.elem (ir, j) = idx_arg.elem (ir, j - 1);
+                  if (tmp_max != 0.)
+                    {
+                      result.xdata (ii) = tmp_max;
+                      result.xridx (ii++) = ir;
+                    }
+                }
+            }
+          result.xcidx (j+1) = ii;
+        }
+    }
+
+  return result;
+}
+
+SparseComplexMatrix
+SparseComplexMatrix::cummin (int dim, bool includenan) const
+{
+  SparseComplexMatrix result;
+  dim_vector dv = dims ();
+  octave_idx_type nr = dv(0);
+  octave_idx_type nc = dv(1);
+
+  if (dim >= dv.ndims ())
+    return *this;
+
+  if (dim < 0)
+    dim = dv.first_non_singleton ();
+
+  if (nr == 0 || nc == 0 || dim >= dv.ndims ())
+    return SparseComplexMatrix (nr, nc);
+
+  if (dim == 0)
+    {
+      octave_idx_type nel = 0;
+      for (octave_idx_type j = 0; j < nc; j++)
+        {
+          octave_idx_type i = cidx (j);
+          if (i < cidx (j+1) && ridx (i) == 0)
+            {
+              octave_idx_type expected_r = 0;
+              for (; i < cidx (j+1) && ridx (i) == expected_r; i++)
+                {
+                  if (octave::math::isnan (data (i)) && includenan)
+                    break;
+                  expected_r++;
+                }
+
+              if (i < cidx (j+1) && ridx (i) == expected_r)
+                {
+                  nel += nr;
+                  continue;
+                }
+              nel += expected_r;
+            }
+          for (; i < cidx (j+1); i++)
+            if (octave::math::isnan (data (i)) && includenan)
+              {
+                nel += nr - ridx (i);
+                break;
+              }
+        }
+
+      result = SparseComplexMatrix (nr, nc, nel);
+      octave_idx_type ii = 0;
+      result.xcidx (0) = 0;
+
+      for (octave_idx_type j = 0; j < nc; j++)
+        {
+          octave_idx_type i = cidx (j);
+          if (i < cidx (j+1))
+            {
+              octave_idx_type last = 0;
+              bool zero_found = ridx (i) > 0;
+              Complex tmp_min = zero_found ? 0. : data (i++);
+
+              if (! zero_found
+                  && ((i < cidx (j+1) && ridx (i) > 1)
+                      || (i == cidx (j+1) && nr >= 2)))
+                {
+                  zero_found = true;
+                  if (! octave::math::isnan (tmp_min) || ! includenan)
+                    {
+                      result.xdata (ii) = tmp_min;
+                      result.xridx (ii++) = 0;
+                      last = 1;
+                      tmp_min = 0.;
+                    }
+                }
+
+              for (; i < cidx (j+1); i++)
+                {
+                  if (data (i) < tmp_min
+                      || (includenan == octave::math::isnan (data (i))
+                          && includenan != octave::math::isnan (tmp_min)))
+                    {
+                      if (tmp_min != 0.)
+                        for (; last < ridx (i); last++)
+                          {
+                            result.xdata (ii) = tmp_min;
+                            result.xridx (ii++) = last;
+                          }
+                      last = ridx (i);
+                      tmp_min = data (i);
+                    }
+                  if (! zero_found
+                      && ((i + 1 < cidx (j+1) && ridx (i+1) > ridx (i) + 1)
+                          || (i + 1 == cidx (j+1) && ridx (i) < nr - 1)))
+                    {
+                      zero_found = true;
+                      if (! octave::math::isnan (tmp_min) || ! includenan)
+                        {
+                          for (; last < ridx (i) + 1; last++)
+                            {
+                              result.xdata (ii) = tmp_min;
+                              result.xridx (ii++) = last;
+                            }
+                          last = ridx (i) + 1;
+                          tmp_min = 0.;
+                        }
+                    }
+                }
+              if (tmp_min != 0.)
+                for (; last < nr; last++)
+                  {
+                    result.xdata (ii) = tmp_min;
+                    result.xridx (ii++) = last;
+                  }
+            }
+          result.xcidx (j+1) = ii;
+        }
+    }
+  else
+    {
+      octave_idx_type nel = 0;
+
+      OCTAVE_LOCAL_BUFFER (octave_idx_type, expected_visit, nr);
+      OCTAVE_LOCAL_BUFFER (int8_t, min_sgn, nr);
+
+      for (octave_idx_type i = 0; i < nr; i++)
+        {
+          expected_visit[i] = 0;
+          min_sgn[i] = 1;
+        }
+
+      for (octave_idx_type j = 0; j < nc; j++)
+        for (octave_idx_type i = cidx (j); i < cidx (j+1); i++)
+          {
+            if (min_sgn[ridx (i)] >= 0)
+              {
+                bool end_of_zeros = (octave::math::isnan (data (i))
+                                     && includenan);
+
+                if (min_sgn[ridx (i)] > 0)
+                  {
+                    if (expected_visit[ridx (i)] < j || end_of_zeros)
+                      {
+                        nel += expected_visit[ridx (i)];
+                        if (expected_visit[ridx (i)] < j)
+                          min_sgn[ridx (i)] = 0;
+                      }
+                    else
+                      expected_visit[ridx (i)]++;
+                  }
+                if (end_of_zeros)
+                  {
+                    min_sgn[ridx (i)] = 1;
+                    nel += nc - j;
+                  }
+              }
+          }
+
+      for (octave_idx_type i = 0; i < nr; i++)
+        if (min_sgn[i] > 0)
+          nel += expected_visit[i];
+
+      result = SparseComplexMatrix (nr, nc, nel);
+      octave_idx_type ii = 0;
+      result.xcidx (0) = 0;
+
+      for (octave_idx_type i = cidx (0); i < cidx (1); i++)
+        {
+          result.xdata (ii) = data (i);
+          result.xridx (ii++) = ridx (i);
+        }
+      result.xcidx (1) = ii;
+
+      for (octave_idx_type j = 1; j < nc; j++)
+        {
+          octave_idx_type i = cidx (j);
+          octave_idx_type i_max = cidx (j+1);
+          bool i_lt_max = i < i_max;
+
+          octave_idx_type r = result.cidx (j-1);
+          octave_idx_type r_max = result.cidx (j);
+          bool r_lt_max = r < r_max;
+
+          while (i_lt_max || r_lt_max)
+            {
+              octave_quit ();
+              Complex i_val, r_val;
+              octave_idx_type row;
+
+              if (! r_lt_max || (i_lt_max && ridx (i) < result.ridx (r)))
+                {
+                  i_val = data (i);
+                  r_val = 0.;
+                  row = ridx (i++);
+                  i_lt_max = i < i_max;
+                }
+              else if (! i_lt_max || (r_lt_max && result.ridx (r) < ridx (i)))
+                {
+                  i_val = 0.;
+                  r_val = result.data (r);
+                  row = result.ridx (r++);
+                  r_lt_max = r < r_max;
+                }
+              else
+                {
+                  i_val = data (i);
+                  r_val = result.data (r);
+                  row = ridx (i++);
+                  i_lt_max = i < i_max;
+                  r++;
+                  r_lt_max = r < r_max;
+                }
+
+              Complex tmp;
+              if (includenan)
+                tmp = r_val <= i_val ? r_val : (octave::math::isnan (r_val)
+                                                ? r_val : i_val);
+              else
+                tmp = octave::math::min (r_val, i_val);
+              if (tmp != 0.)
+                {
+                  result.data (ii) = tmp;
+                  result.ridx (ii++) = row;
+                }
+            }
+          result.xcidx (j+1) = ii;
+        }
+    }
+
+  return result;
+}
+
+SparseComplexMatrix
+SparseComplexMatrix::cummin (Array<octave_idx_type>& idx_arg,
+                             int dim, bool includenan) const
+{
+  SparseComplexMatrix result;
+  dim_vector dv = dims ();
+  octave_idx_type nr = dv(0);
+  octave_idx_type nc = dv(1);
+
+  if (dim >= dv.ndims ())
+    {
+      idx_arg.resize (dim_vector (nr, nc), 0);
+      return *this;
+    }
+
+  if (dim < 0)
+    dim = dv.first_non_singleton ();
+
+  idx_arg.resize (dim_vector (nr, nc));
+
+  if (nr == 0 || nc == 0 || dim >= dv.ndims ())
+    return SparseComplexMatrix (nr, nc);
+
+  if (dim == 0)
+    {
+      octave_idx_type nel = 0;
+      for (octave_idx_type j = 0; j < nc; j++)
+        {
+          octave_idx_type i = cidx (j);
+          if (i < cidx (j+1) && ridx (i) == 0)
+            {
+              octave_idx_type expected_r = 0;
+              for (; i < cidx (j+1) && ridx (i) == expected_r; i++)
+                {
+                  if (octave::math::isnan (data (i)) && includenan)
+                    break;
+                  expected_r++;
+                }
+
+              if (i < cidx (j+1) && ridx (i) == expected_r)
+                {
+                  nel += nr;
+                  continue;
+                }
+              nel += expected_r;
+            }
+          for (; i < cidx (j+1); i++)
+            if (octave::math::isnan (data (i)) && includenan)
+              {
+                nel += nr - ridx (i);
+                break;
+              }
+        }
+
+      result = SparseComplexMatrix (nr, nc, nel);
+      octave_idx_type ii = 0;
+      result.xcidx (0) = 0;
+      octave_idx_type i = cidx (0);
+
+      for (octave_idx_type j = 0; j < nc; j++)
+        {
+          Complex tmp_min = i < cidx (j+1) && ridx (i) == 0 ? data (i++) : 0.;
+          idx_arg.elem (0, j) = 0;
+          if (tmp_min != 0.)
+            {
+              result.xdata (ii) = tmp_min;
+              result.xridx (ii++) = 0;
+            }
+
+          for (octave_idx_type ir = 1; ir < nr; ir++)
+            {
+              Complex tmp = i < cidx (j+1) && ridx (i) == ir ? data (i++) : 0.;
+
+              if (tmp < tmp_min
+                  || (includenan == octave::math::isnan (tmp)
+                      && includenan != octave::math::isnan (tmp_min)))
+                {
+                  tmp_min = tmp;
+                  idx_arg.elem (ir, j) = ir;
+                }
+              else
+                idx_arg.elem (ir, j) = idx_arg.elem (ir - 1, j);
+              if (tmp_min != 0.)
+                {
+                  result.xdata (ii) = tmp_min;
+                  result.xridx (ii++) = ir;
+                }
+            }
+
+          result.xcidx (j+1) = ii;
+        }
+    }
+  else
+    {
+      octave_idx_type nel = 0;
+
+      OCTAVE_LOCAL_BUFFER (octave_idx_type, expected_visit, nr);
+      OCTAVE_LOCAL_BUFFER (int8_t, min_sgn, nr);
+
+      for (octave_idx_type i = 0; i < nr; i++)
+        {
+          expected_visit[i] = 0;
+          min_sgn[i] = 1;
+        }
+
+      for (octave_idx_type j = 0; j < nc; j++)
+        for (octave_idx_type i = cidx (j); i < cidx (j+1); i++)
+          {
+            if (min_sgn[ridx (i)] >= 0)
+              {
+                bool end_of_zeros = (octave::math::isnan (data (i))
+                                     && includenan);
+
+                if (min_sgn[ridx (i)] > 0)
+                  {
+                    if (expected_visit[ridx (i)] < j || end_of_zeros)
+                      {
+                        nel += expected_visit[ridx (i)];
+                        if (expected_visit[ridx (i)] < j)
+                          min_sgn[ridx (i)] = 0;
+                      }
+                    else
+                      expected_visit[ridx (i)]++;
+                  }
+                if (end_of_zeros)
+                  {
+                    min_sgn[ridx (i)] = 1;
+                    nel += nc - j;
+                  }
+              }
+          }
+
+      for (octave_idx_type i = 0; i < nr; i++)
+        if (min_sgn[i] > 0)
+          nel += expected_visit[i];
+
+      result = SparseComplexMatrix (nr, nc, nel);
+      octave_idx_type ii = 0;
+      result.xcidx (0) = 0;
+
+      octave_idx_type i = cidx (0);
+      for (octave_idx_type ir = 0; ir < nr; ir++)
+        {
+          idx_arg.elem (ir, 0) = 0;
+          if (i < cidx (1) && ridx (i) == ir)
+            {
+              result.xdata (ii) = data (i++);
+              result.xridx (ii++) = ir;
+            }
+        }
+      result.xcidx (1) = ii;
+      octave_idx_type r = result.cidx (0);
+
+      for (octave_idx_type j = 1; j < nc; j++)
+        {
+          for (octave_idx_type ir = 0; ir < nr; ir++)
+            {
+              Complex tmp_min = (r < result.cidx (j) && result.ridx (r) == ir
+                                 ? result.data (r++) : 0.);
+              Complex tmp = i < cidx (j+1) && ridx (i) == ir ? data (i++) : 0.;
+              if (tmp < tmp_min
+                  || (includenan == octave::math::isnan (tmp)
+                      && includenan != octave::math::isnan (tmp_min)))
+                {
+                  idx_arg.elem (ir, j) = j;
+                  if (tmp != 0.)
+                    {
+                      result.xdata (ii) = tmp;
+                      result.xridx (ii++) = ir;
+                    }
+                }
+              else
+                {
+                  idx_arg.elem (ir, j) = idx_arg.elem (ir, j - 1);
+                  if (tmp_min != 0.)
+                    {
+                      result.xdata (ii) = tmp_min;
+                      result.xridx (ii++) = ir;
+                    }
+                }
+            }
+          result.xcidx (j+1) = ii;
+        }
+    }
+
+  return result;
+}
+
+/*
+
+%!test
+%! x = kron (eye (4), sparse (1, 1, 1, 2^14, 2^14) * i);
+%! assert (sum (sum (cummax (x, 1))), sparse ((2^17 + 2^15) * i));
+%! assert (sum (sum (cummax (x, 2))), sparse ((2^17 + 2^15) * i));
+%! assert (sum (sum (cummin (x, 1))), sparse (i));
+%! assert (sum (sum (cummin (x, 2))), sparse (i));
+
+*/
+
 ComplexRowVector
 SparseComplexMatrix::row (octave_idx_type i) const
 {
@@ -7668,7 +8559,7 @@ operator * (const SparseComplexMatrix& a
     return T (nr, nc);
 
 SparseComplexMatrix
-min (const Complex& c, const SparseComplexMatrix& m)
+min (const Complex& c, const SparseComplexMatrix& m, bool includenan)
 {
   SparseComplexMatrix result;
 
@@ -7678,7 +8569,43 @@ min (const Complex& c, const SparseCompl
   EMPTY_RETURN_CHECK (SparseComplexMatrix);
 
   if (abs (c) == 0.)
-    return SparseComplexMatrix (nr, nc);
+    {
+      if (includenan)
+        {
+          octave_idx_type nel = 0;
+          for (octave_idx_type j = 0; j < nc; j++)
+            for (octave_idx_type i = m.cidx (j); i < m.cidx (j+1); i++)
+              if (octave::math::isnan (m.data (i)))
+                nel++;
+          result = SparseComplexMatrix (nr, nc, nel);
+
+          octave_idx_type ii = 0;
+          result.xcidx (0) = 0;
+          for (octave_idx_type j = 0; j < nc; j++)
+            {
+              for (octave_idx_type i = m.cidx (j); i < m.cidx (j+1); i++)
+                if (octave::math::isnan (m.data (i)))
+                  {
+                    result.xdata (ii) = m.data (i);
+                    result.xridx (ii++) = m.ridx (i);
+                  }
+              result.xcidx (j+1) = ii;
+            }
+        }
+      else
+        return SparseComplexMatrix (nr, nc);
+    }
+  else if (includenan)
+    {
+      if (octave::math::isnan (c))
+        return SparseComplexMatrix (nr, nc, c);
+
+      result = SparseComplexMatrix (m);
+      for (octave_idx_type j = 0; j < nc; j++)
+        for (octave_idx_type i = m.cidx (j); i < m.cidx (j+1); i++)
+          if (c < m.data (i))
+            result.data (i) = c;
+    }
   else
     {
       result = SparseComplexMatrix (m);
@@ -7692,13 +8619,31 @@ min (const Complex& c, const SparseCompl
 }
 
 SparseComplexMatrix
-min (const SparseComplexMatrix& m, const Complex& c)
-{
-  return min (c, m);
+min (const SparseComplexMatrix& m, const Complex& c, bool includenan)
+{
+  if (! octave::math::isnan (c))
+    return min (c, m, includenan);
+
+  if (! includenan)
+    return m;
+
+  octave_idx_type nr = m.rows ();
+  octave_idx_type nc = m.columns ();
+
+  EMPTY_RETURN_CHECK (SparseComplexMatrix);
+
+  SparseComplexMatrix result (nr, nc, c);
+  for (octave_idx_type j = 0; j < nc; j++)
+    for (octave_idx_type i = m.cidx (j); i < m.cidx (j+1); i++)
+      if (octave::math::isnan (m.data (i)))
+        result.xdata (m.ridx (i) + j * nr) = m.data (i);
+
+  return result;
 }
 
 SparseComplexMatrix
-min (const SparseComplexMatrix& a, const SparseComplexMatrix& b)
+min (const SparseComplexMatrix& a, const SparseComplexMatrix& b,
+     bool includenan)
 {
   SparseComplexMatrix r;
 
@@ -7728,11 +8673,10 @@ min (const SparseComplexMatrix& a, const
               octave_quit ();
               if ((! jb_lt_max) || (ja_lt_max && (a.ridx (ja) < b.ridx (jb))))
                 {
-                  Complex tmp = octave::math::min (a.data (ja), 0.);
-                  if (tmp != 0.)
+                  if (octave::math::isnan (a.data (ja)) && includenan)
                     {
                       r.ridx (jx) = a.ridx (ja);
-                      r.data (jx) = tmp;
+                      r.data (jx) = a.data (ja);
                       jx++;
                     }
                   ja++;
@@ -7741,11 +8685,10 @@ min (const SparseComplexMatrix& a, const
               else if ((! ja_lt_max)
                        || (jb_lt_max && (b.ridx (jb) < a.ridx (ja))))
                 {
-                  Complex tmp = octave::math::min (0., b.data (jb));
-                  if (tmp != 0.)
+                  if (octave::math::isnan (b.data (jb)) && includenan)
                     {
                       r.ridx (jx) = b.ridx (jb);
-                      r.data (jx) = tmp;
+                      r.data (jx) = b.data (jb);
                       jx++;
                     }
                   jb++;
